//Brian Voils
//CST 116
//Lab 5, Pg. 315 #4


/*
 * Example 5.16
 * Program to play a guessing game.  The computer selects a
 * number at random in the range from 0 through HIGH (100) -
 * 1 and the user repeatedly tries to guess the number
 */

#include <stdio.h>
#include "c:\brian\c++\shiflet\RandDef.h"

void initialize(void);
int ReadGuess(void);
void PlayGame(int target);
int AskPlay(void);

#define HIGH 100
#define FALSE 0
#define TRUE  1

main()
{
	int target;			/* computer's number */
	int i=1;

	initialize();
	
	while (i>0)
	{
		target = random(HIGH);
		PlayGame(target);
		i=AskPlay();
	}
	return 0;
}

/*
 * Function to print game instructions and seed the random
 * number generator
 * Pre:   none
 * Post:  The game's instructions have been displayed and
 *        the random number generator has been seeded.
 */

void initialize(void)
{
	SeedRand();

	printf("Welcome to the GUESSING GAME!\n\n");
	printf("I'm thinking of a number between 0 and %d.\n", HIGH - 1);
	printf("Enter your guess.\n");
	printf("I'll tell you whether to guess higher or lower.\n\n");
}

/*
 * Function to allow the user to play the game
 * Pre:   target is an integer between 0 and HIGH - 1.
 * Post:  target has been guessed by the user.
 */

void PlayGame(int target)
{
	int ReadGuess(void);
	int guess,						/* user's guess */
	    GuessAgain = TRUE;
		
	do
	{
		guess = ReadGuess();
		if (guess < target)
			printf("Guess higher\n\n");
		else if (guess > target)
			printf("Guess lower\n\n");
		else
		{
			printf("Congratulations! You guessed it!\n");
			GuessAgain = FALSE;
		}
	}
	while (GuessAgain);	/* continue while GuessAgain is TRUE */
}

/*
 * Function to prompt for and read an integer to return to main
 * Pre:   none
 * Post:  User's guess has been returned.
 */

int ReadGuess(void)
{
	int guess;						/* user's guess */

	printf("Enter a guess: ");
	scanf("%d", &guess);	
	return guess;
}

int AskPlay(void)
{
	int ans;

	do
	{
		printf("Would you like to play again?\n");
		printf("Enter '1' for 'yes' and '0' for 'no.'");
		scanf("%d", &ans);
		printf("\n");
	}
	while ((ans!=0)&&(ans!=1));
	return ans;
}